# -*- coding: utf-8 -*-

#global block_parameter_defaults

conv_types = {'double':'real', 'single':'real', 'int8':'int', 'int16':'int', 'int32':'int', 'uint8':'nat', 'uint16':'nat', 'uint32':'nat', 'boolean':'bool'}

class Variables:
	names = "abcdefghijklmnopqrstuvwxyz"
	excluded_names = ["hd", "id", "o", "if", "of", "wf", "c", "ii", "pi", "vc", "vce", "vr", "vl"]
	nlen = len(names)
	def __init__(self):
		self.state_variables = {}
		self.index = 0
	
	def update_excluded_names(self, names):
		Variables.excluded_names = Variables.excluded_names + names
		
	def get_next_var_name(self):
		i = self.index
		var_name = self.names[i % self.nlen]
		while i / self.nlen:
			i = i / self.nlen - 1
			var_name = var_name + self.names[i % self.nlen]
		self.index += 1
		if var_name in Variables.excluded_names:
			return self.get_next_var_name()
		return var_name
		
		
	def get_var(self, port):
		if port.get_direction() == 'sin':
			pref = "si_"
		elif port.get_direction() == 'sout':
			pref = "so_"
		else:
			return self.get_next_var_name()
			
		id_block = port.get_parent_id()
		if id_block in self.state_variables.keys():
			# we use the old name of the variable
			return pref + self.state_variables[id_block]
		else:
			# we create a new state variable name, and associate it with the block id
			var_name = self.get_next_var_name()
			self.state_variables[id_block] = var_name
			return pref + var_name
			
			
def init():
	global block_parameter_defaults
	block_parameter_defaults = {}
	global child2parent
	child2parent = {}
	global sid2element
	sid2element = {}
	
	global tindex
	tindex = 0
	
	global variable_names
	variable_names = Variables()
	
